#include <hxcpp.h>

#ifndef INCLUDED_Lambda
#include <Lambda.h>
#endif
#ifndef INCLUDED_Std
#include <Std.h>
#endif
#ifndef INCLUDED_luxe_ID
#include <luxe/ID.h>
#endif
#ifndef INCLUDED_luxe_resource_Resource
#include <luxe/resource/Resource.h>
#endif
#ifndef INCLUDED_phoenix_Batcher
#include <phoenix/Batcher.h>
#endif
#ifndef INCLUDED_phoenix_Color
#include <phoenix/Color.h>
#endif
#ifndef INCLUDED_phoenix_PrimitiveType
#include <phoenix/PrimitiveType.h>
#endif
#ifndef INCLUDED_phoenix_Rectangle
#include <phoenix/Rectangle.h>
#endif
#ifndef INCLUDED_phoenix_Shader
#include <phoenix/Shader.h>
#endif
#ifndef INCLUDED_phoenix_Texture
#include <phoenix/Texture.h>
#endif
#ifndef INCLUDED_phoenix_Transform
#include <phoenix/Transform.h>
#endif
#ifndef INCLUDED_phoenix_Vector
#include <phoenix/Vector.h>
#endif
#ifndef INCLUDED_phoenix_geometry_CompositeGeometry
#include <phoenix/geometry/CompositeGeometry.h>
#endif
#ifndef INCLUDED_phoenix_geometry_Geometry
#include <phoenix/geometry/Geometry.h>
#endif
namespace phoenix{
namespace geometry{

Void CompositeGeometry_obj::__construct(Dynamic _options)
{
HX_STACK_FRAME("phoenix.geometry.CompositeGeometry","new",0x5514d06e,"phoenix.geometry.CompositeGeometry.new","phoenix/geometry/CompositeGeometry.hx",20,0xbffd3ea2)

HX_STACK_ARG(_options,"_options")
{
	HX_STACK_LINE(22)
	super::__construct(_options);
	HX_STACK_LINE(24)
	this->geometry = Array_obj< ::Dynamic >::__new();
}
;
	return null();
}

//CompositeGeometry_obj::~CompositeGeometry_obj() { }

Dynamic CompositeGeometry_obj::__CreateEmpty() { return  new CompositeGeometry_obj; }
hx::ObjectPtr< CompositeGeometry_obj > CompositeGeometry_obj::__new(Dynamic _options)
{  hx::ObjectPtr< CompositeGeometry_obj > result = new CompositeGeometry_obj();
	result->__construct(_options);
	return result;}

Dynamic CompositeGeometry_obj::__Create(hx::DynamicArray inArgs)
{  hx::ObjectPtr< CompositeGeometry_obj > result = new CompositeGeometry_obj();
	result->__construct(inArgs[0]);
	return result;}

::String CompositeGeometry_obj::toString( ){
	HX_STACK_FRAME("phoenix.geometry.CompositeGeometry","toString",0xa10cddde,"phoenix.geometry.CompositeGeometry.toString","phoenix/geometry/CompositeGeometry.hx",28,0xbffd3ea2)
	HX_STACK_THIS(this)
	HX_STACK_LINE(30)
	::String _g = ((HX_CSTRING("CompositeGeometry ") + ::Std_obj::string(this->geometry)) + HX_CSTRING(" : "));		HX_STACK_VAR(_g,"_g");
	HX_STACK_LINE(30)
	return (_g + ::Std_obj::string(this->geometry));
}


HX_DEFINE_DYNAMIC_FUNC0(CompositeGeometry_obj,toString,return )

Void CompositeGeometry_obj::clear( ){
{
		HX_STACK_FRAME("phoenix.geometry.CompositeGeometry","clear",0x0f67111b,"phoenix.geometry.CompositeGeometry.clear","phoenix/geometry/CompositeGeometry.hx",37,0xbffd3ea2)
		HX_STACK_THIS(this)
		HX_STACK_LINE(37)
		this->geometry->splice((int)0,this->geometry->length);
	}
return null();
}


HX_DEFINE_DYNAMIC_FUNC0(CompositeGeometry_obj,clear,(void))

Void CompositeGeometry_obj::replace( Array< ::Dynamic > _geometry){
{
		HX_STACK_FRAME("phoenix.geometry.CompositeGeometry","replace",0x04056742,"phoenix.geometry.CompositeGeometry.replace","phoenix/geometry/CompositeGeometry.hx",42,0xbffd3ea2)
		HX_STACK_THIS(this)
		HX_STACK_ARG(_geometry,"_geometry")
		HX_STACK_LINE(45)
		this->clear();
		HX_STACK_LINE(47)
		this->geometry = _geometry;
		HX_STACK_LINE(49)
		{
			HX_STACK_LINE(49)
			int _g = (int)0;		HX_STACK_VAR(_g,"_g");
			HX_STACK_LINE(49)
			Array< ::Dynamic > _g1 = this->geometry;		HX_STACK_VAR(_g1,"_g1");
			HX_STACK_LINE(49)
			while(((_g < _g1->length))){
				HX_STACK_LINE(49)
				::phoenix::geometry::Geometry geom = _g1->__get(_g).StaticCast< ::phoenix::geometry::Geometry >();		HX_STACK_VAR(geom,"geom");
				HX_STACK_LINE(49)
				++(_g);
				HX_STACK_LINE(50)
				geom->transform = this->transform;
			}
		}
	}
return null();
}


HX_DEFINE_DYNAMIC_FUNC1(CompositeGeometry_obj,replace,(void))

bool CompositeGeometry_obj::has_geometry( ::phoenix::geometry::Geometry geom){
	HX_STACK_FRAME("phoenix.geometry.CompositeGeometry","has_geometry",0x14ef8da9,"phoenix.geometry.CompositeGeometry.has_geometry","phoenix/geometry/CompositeGeometry.hx",57,0xbffd3ea2)
	HX_STACK_THIS(this)
	HX_STACK_ARG(geom,"geom")
	HX_STACK_LINE(57)
	return ::Lambda_obj::has(this->geometry,geom);
}


HX_DEFINE_DYNAMIC_FUNC1(CompositeGeometry_obj,has_geometry,return )

Void CompositeGeometry_obj::add_geometry( ::phoenix::geometry::Geometry geom){
{
		HX_STACK_FRAME("phoenix.geometry.CompositeGeometry","add_geometry",0x86f1ca02,"phoenix.geometry.CompositeGeometry.add_geometry","phoenix/geometry/CompositeGeometry.hx",63,0xbffd3ea2)
		HX_STACK_THIS(this)
		HX_STACK_ARG(geom,"geom")
		HX_STACK_LINE(63)
		if (((geom != null()))){
			HX_STACK_LINE(64)
			geom->transform = this->transform;
			HX_STACK_LINE(65)
			this->geometry->push(geom);
		}
	}
return null();
}


HX_DEFINE_DYNAMIC_FUNC1(CompositeGeometry_obj,add_geometry,(void))

Void CompositeGeometry_obj::remove_geometry( ::phoenix::geometry::Geometry g){
{
		HX_STACK_FRAME("phoenix.geometry.CompositeGeometry","remove_geometry",0x7c52925b,"phoenix.geometry.CompositeGeometry.remove_geometry","phoenix/geometry/CompositeGeometry.hx",72,0xbffd3ea2)
		HX_STACK_THIS(this)
		HX_STACK_ARG(g,"g")
		HX_STACK_LINE(72)
		this->geometry->remove(g);
	}
return null();
}


HX_DEFINE_DYNAMIC_FUNC1(CompositeGeometry_obj,remove_geometry,(void))

Void CompositeGeometry_obj::add_to_batcher( ::phoenix::Batcher _batcher){
{
		HX_STACK_FRAME("phoenix.geometry.CompositeGeometry","add_to_batcher",0x7fb88ff3,"phoenix.geometry.CompositeGeometry.add_to_batcher","phoenix/geometry/CompositeGeometry.hx",78,0xbffd3ea2)
		HX_STACK_THIS(this)
		HX_STACK_ARG(_batcher,"_batcher")
		HX_STACK_LINE(78)
		int _g = (int)0;		HX_STACK_VAR(_g,"_g");
		HX_STACK_LINE(78)
		Array< ::Dynamic > _g1 = this->geometry;		HX_STACK_VAR(_g1,"_g1");
		HX_STACK_LINE(78)
		while(((_g < _g1->length))){
			HX_STACK_LINE(78)
			::phoenix::geometry::Geometry geom = _g1->__get(_g).StaticCast< ::phoenix::geometry::Geometry >();		HX_STACK_VAR(geom,"geom");
			HX_STACK_LINE(78)
			++(_g);
			HX_STACK_LINE(79)
			_batcher->add(geom,null());
		}
	}
return null();
}


HX_DEFINE_DYNAMIC_FUNC1(CompositeGeometry_obj,add_to_batcher,(void))

Void CompositeGeometry_obj::drop( Dynamic __o_remove){
Dynamic remove = __o_remove.Default(true);
	HX_STACK_FRAME("phoenix.geometry.CompositeGeometry","drop",0x168f4461,"phoenix.geometry.CompositeGeometry.drop","phoenix/geometry/CompositeGeometry.hx",84,0xbffd3ea2)
	HX_STACK_THIS(this)
	HX_STACK_ARG(remove,"remove")
{
		HX_STACK_LINE(86)
		{
			HX_STACK_LINE(86)
			int _g = (int)0;		HX_STACK_VAR(_g,"_g");
			HX_STACK_LINE(86)
			Array< ::Dynamic > _g1 = this->geometry;		HX_STACK_VAR(_g1,"_g1");
			HX_STACK_LINE(86)
			while(((_g < _g1->length))){
				HX_STACK_LINE(86)
				::phoenix::geometry::Geometry geom = _g1->__get(_g).StaticCast< ::phoenix::geometry::Geometry >();		HX_STACK_VAR(geom,"geom");
				HX_STACK_LINE(86)
				++(_g);
				HX_STACK_LINE(87)
				geom->drop(remove);
				HX_STACK_LINE(88)
				geom = null();
			}
		}
		HX_STACK_LINE(91)
		this->geometry = null();
		HX_STACK_LINE(92)
		this->geometry = Array_obj< ::Dynamic >::__new();
	}
return null();
}


Void CompositeGeometry_obj::translate( ::phoenix::Vector _offset){
{
		HX_STACK_FRAME("phoenix.geometry.CompositeGeometry","translate",0x6b2d55dc,"phoenix.geometry.CompositeGeometry.translate","phoenix/geometry/CompositeGeometry.hx",98,0xbffd3ea2)
		HX_STACK_THIS(this)
		HX_STACK_ARG(_offset,"_offset")
		HX_STACK_LINE(98)
		if (((this->geometry != null()))){
			HX_STACK_LINE(99)
			int _g = (int)0;		HX_STACK_VAR(_g,"_g");
			HX_STACK_LINE(99)
			Array< ::Dynamic > _g1 = this->geometry;		HX_STACK_VAR(_g1,"_g1");
			HX_STACK_LINE(99)
			while(((_g < _g1->length))){
				HX_STACK_LINE(99)
				::phoenix::geometry::Geometry geom = _g1->__get(_g).StaticCast< ::phoenix::geometry::Geometry >();		HX_STACK_VAR(geom,"geom");
				HX_STACK_LINE(99)
				++(_g);
				HX_STACK_LINE(100)
				geom->translate(_offset);
			}
		}
	}
return null();
}


::phoenix::Color CompositeGeometry_obj::set_color( ::phoenix::Color _color){
	HX_STACK_FRAME("phoenix.geometry.CompositeGeometry","set_color",0x93043854,"phoenix.geometry.CompositeGeometry.set_color","phoenix/geometry/CompositeGeometry.hx",110,0xbffd3ea2)
	HX_STACK_THIS(this)
	HX_STACK_ARG(_color,"_color")
	HX_STACK_LINE(112)
	if (((this->geometry != null()))){
		HX_STACK_LINE(113)
		int _g = (int)0;		HX_STACK_VAR(_g,"_g");
		HX_STACK_LINE(113)
		Array< ::Dynamic > _g1 = this->geometry;		HX_STACK_VAR(_g1,"_g1");
		HX_STACK_LINE(113)
		while(((_g < _g1->length))){
			HX_STACK_LINE(113)
			::phoenix::geometry::Geometry geom = _g1->__get(_g).StaticCast< ::phoenix::geometry::Geometry >();		HX_STACK_VAR(geom,"geom");
			HX_STACK_LINE(113)
			++(_g);
			HX_STACK_LINE(114)
			geom->set_color(_color);
		}
	}
	HX_STACK_LINE(118)
	return this->color = _color;
}


::phoenix::PrimitiveType CompositeGeometry_obj::set_primitive_type( ::phoenix::PrimitiveType val){
	HX_STACK_FRAME("phoenix.geometry.CompositeGeometry","set_primitive_type",0x11b81b81,"phoenix.geometry.CompositeGeometry.set_primitive_type","phoenix/geometry/CompositeGeometry.hx",122,0xbffd3ea2)
	HX_STACK_THIS(this)
	HX_STACK_ARG(val,"val")
	HX_STACK_LINE(124)
	if (((this->geometry != null()))){
		HX_STACK_LINE(125)
		int _g = (int)0;		HX_STACK_VAR(_g,"_g");
		HX_STACK_LINE(125)
		Array< ::Dynamic > _g1 = this->geometry;		HX_STACK_VAR(_g1,"_g1");
		HX_STACK_LINE(125)
		while(((_g < _g1->length))){
			HX_STACK_LINE(125)
			::phoenix::geometry::Geometry geom = _g1->__get(_g).StaticCast< ::phoenix::geometry::Geometry >();		HX_STACK_VAR(geom,"geom");
			HX_STACK_LINE(125)
			++(_g);
			HX_STACK_LINE(126)
			geom->set_primitive_type(val);
		}
	}
	HX_STACK_LINE(130)
	return this->primitive_type = val;
}


::phoenix::Shader CompositeGeometry_obj::set_shader( ::phoenix::Shader val){
	HX_STACK_FRAME("phoenix.geometry.CompositeGeometry","set_shader",0x67470b14,"phoenix.geometry.CompositeGeometry.set_shader","phoenix/geometry/CompositeGeometry.hx",134,0xbffd3ea2)
	HX_STACK_THIS(this)
	HX_STACK_ARG(val,"val")
	HX_STACK_LINE(136)
	if (((this->geometry != null()))){
		HX_STACK_LINE(137)
		int _g = (int)0;		HX_STACK_VAR(_g,"_g");
		HX_STACK_LINE(137)
		Array< ::Dynamic > _g1 = this->geometry;		HX_STACK_VAR(_g1,"_g1");
		HX_STACK_LINE(137)
		while(((_g < _g1->length))){
			HX_STACK_LINE(137)
			::phoenix::geometry::Geometry geom = _g1->__get(_g).StaticCast< ::phoenix::geometry::Geometry >();		HX_STACK_VAR(geom,"geom");
			HX_STACK_LINE(137)
			++(_g);
			HX_STACK_LINE(138)
			geom->set_shader(val);
		}
	}
	HX_STACK_LINE(142)
	return this->shader = val;
}


::phoenix::Texture CompositeGeometry_obj::set_texture( ::phoenix::Texture val){
	HX_STACK_FRAME("phoenix.geometry.CompositeGeometry","set_texture",0x363cee0c,"phoenix.geometry.CompositeGeometry.set_texture","phoenix/geometry/CompositeGeometry.hx",146,0xbffd3ea2)
	HX_STACK_THIS(this)
	HX_STACK_ARG(val,"val")
	HX_STACK_LINE(148)
	if (((this->geometry != null()))){
		HX_STACK_LINE(150)
		int _g = (int)0;		HX_STACK_VAR(_g,"_g");
		HX_STACK_LINE(150)
		Array< ::Dynamic > _g1 = this->geometry;		HX_STACK_VAR(_g1,"_g1");
		HX_STACK_LINE(150)
		while(((_g < _g1->length))){
			HX_STACK_LINE(150)
			::phoenix::geometry::Geometry geom = _g1->__get(_g).StaticCast< ::phoenix::geometry::Geometry >();		HX_STACK_VAR(geom,"geom");
			HX_STACK_LINE(150)
			++(_g);
			HX_STACK_LINE(151)
			geom->set_texture(val);
		}
	}
	HX_STACK_LINE(155)
	return this->texture = val;
}


Float CompositeGeometry_obj::set_depth( Float val){
	HX_STACK_FRAME("phoenix.geometry.CompositeGeometry","set_depth",0x1fd1b7f4,"phoenix.geometry.CompositeGeometry.set_depth","phoenix/geometry/CompositeGeometry.hx",159,0xbffd3ea2)
	HX_STACK_THIS(this)
	HX_STACK_ARG(val,"val")
	HX_STACK_LINE(161)
	if (((this->geometry != null()))){
		HX_STACK_LINE(162)
		int _g = (int)0;		HX_STACK_VAR(_g,"_g");
		HX_STACK_LINE(162)
		Array< ::Dynamic > _g1 = this->geometry;		HX_STACK_VAR(_g1,"_g1");
		HX_STACK_LINE(162)
		while(((_g < _g1->length))){
			HX_STACK_LINE(162)
			::phoenix::geometry::Geometry geom = _g1->__get(_g).StaticCast< ::phoenix::geometry::Geometry >();		HX_STACK_VAR(geom,"geom");
			HX_STACK_LINE(162)
			++(_g);
			HX_STACK_LINE(163)
			geom->set_depth(val);
		}
	}
	HX_STACK_LINE(167)
	return this->depth = val;
}


int CompositeGeometry_obj::set_group( int val){
	HX_STACK_FRAME("phoenix.geometry.CompositeGeometry","set_group",0xe29c7a30,"phoenix.geometry.CompositeGeometry.set_group","phoenix/geometry/CompositeGeometry.hx",171,0xbffd3ea2)
	HX_STACK_THIS(this)
	HX_STACK_ARG(val,"val")
	HX_STACK_LINE(173)
	if (((this->geometry != null()))){
		HX_STACK_LINE(174)
		int _g = (int)0;		HX_STACK_VAR(_g,"_g");
		HX_STACK_LINE(174)
		Array< ::Dynamic > _g1 = this->geometry;		HX_STACK_VAR(_g1,"_g1");
		HX_STACK_LINE(174)
		while(((_g < _g1->length))){
			HX_STACK_LINE(174)
			::phoenix::geometry::Geometry geom = _g1->__get(_g).StaticCast< ::phoenix::geometry::Geometry >();		HX_STACK_VAR(geom,"geom");
			HX_STACK_LINE(174)
			++(_g);
			HX_STACK_LINE(175)
			geom->set_group(val);
		}
	}
	HX_STACK_LINE(179)
	return this->group = val;
}


bool CompositeGeometry_obj::set_locked( bool val){
	HX_STACK_FRAME("phoenix.geometry.CompositeGeometry","set_locked",0xa3ed50f9,"phoenix.geometry.CompositeGeometry.set_locked","phoenix/geometry/CompositeGeometry.hx",183,0xbffd3ea2)
	HX_STACK_THIS(this)
	HX_STACK_ARG(val,"val")
	HX_STACK_LINE(185)
	if (((this->geometry != null()))){
		HX_STACK_LINE(186)
		int _g = (int)0;		HX_STACK_VAR(_g,"_g");
		HX_STACK_LINE(186)
		Array< ::Dynamic > _g1 = this->geometry;		HX_STACK_VAR(_g1,"_g1");
		HX_STACK_LINE(186)
		while(((_g < _g1->length))){
			HX_STACK_LINE(186)
			::phoenix::geometry::Geometry geom = _g1->__get(_g).StaticCast< ::phoenix::geometry::Geometry >();		HX_STACK_VAR(geom,"geom");
			HX_STACK_LINE(186)
			++(_g);
			HX_STACK_LINE(187)
			geom->set_locked(val);
		}
	}
	HX_STACK_LINE(191)
	return this->locked = val;
}


bool CompositeGeometry_obj::set_dirty( bool val){
	HX_STACK_FRAME("phoenix.geometry.CompositeGeometry","set_dirty",0x22781703,"phoenix.geometry.CompositeGeometry.set_dirty","phoenix/geometry/CompositeGeometry.hx",195,0xbffd3ea2)
	HX_STACK_THIS(this)
	HX_STACK_ARG(val,"val")
	HX_STACK_LINE(197)
	if (((this->geometry != null()))){
		HX_STACK_LINE(198)
		int _g = (int)0;		HX_STACK_VAR(_g,"_g");
		HX_STACK_LINE(198)
		Array< ::Dynamic > _g1 = this->geometry;		HX_STACK_VAR(_g1,"_g1");
		HX_STACK_LINE(198)
		while(((_g < _g1->length))){
			HX_STACK_LINE(198)
			::phoenix::geometry::Geometry geom = _g1->__get(_g).StaticCast< ::phoenix::geometry::Geometry >();		HX_STACK_VAR(geom,"geom");
			HX_STACK_LINE(198)
			++(_g);
			HX_STACK_LINE(199)
			geom->set_dirty(val);
		}
	}
	HX_STACK_LINE(203)
	return this->dirty = val;
}


::phoenix::Rectangle CompositeGeometry_obj::set_clip_rect( ::phoenix::Rectangle val){
	HX_STACK_FRAME("phoenix.geometry.CompositeGeometry","set_clip_rect",0xcc36dba4,"phoenix.geometry.CompositeGeometry.set_clip_rect","phoenix/geometry/CompositeGeometry.hx",207,0xbffd3ea2)
	HX_STACK_THIS(this)
	HX_STACK_ARG(val,"val")
	HX_STACK_LINE(209)
	if (((this->geometry != null()))){
		HX_STACK_LINE(210)
		int _g = (int)0;		HX_STACK_VAR(_g,"_g");
		HX_STACK_LINE(210)
		Array< ::Dynamic > _g1 = this->geometry;		HX_STACK_VAR(_g1,"_g1");
		HX_STACK_LINE(210)
		while(((_g < _g1->length))){
			HX_STACK_LINE(210)
			::phoenix::geometry::Geometry geom = _g1->__get(_g).StaticCast< ::phoenix::geometry::Geometry >();		HX_STACK_VAR(geom,"geom");
			HX_STACK_LINE(210)
			++(_g);
			HX_STACK_LINE(211)
			geom->set_clip_rect(val);
		}
	}
	HX_STACK_LINE(215)
	return this->clip_rect = val;
}


bool CompositeGeometry_obj::set_visible( bool val){
	HX_STACK_FRAME("phoenix.geometry.CompositeGeometry","set_visible",0x3a809da3,"phoenix.geometry.CompositeGeometry.set_visible","phoenix/geometry/CompositeGeometry.hx",219,0xbffd3ea2)
	HX_STACK_THIS(this)
	HX_STACK_ARG(val,"val")
	HX_STACK_LINE(221)
	if (((this->geometry != null()))){
		HX_STACK_LINE(222)
		int _g = (int)0;		HX_STACK_VAR(_g,"_g");
		HX_STACK_LINE(222)
		Array< ::Dynamic > _g1 = this->geometry;		HX_STACK_VAR(_g1,"_g1");
		HX_STACK_LINE(222)
		while(((_g < _g1->length))){
			HX_STACK_LINE(222)
			::phoenix::geometry::Geometry geom = _g1->__get(_g).StaticCast< ::phoenix::geometry::Geometry >();		HX_STACK_VAR(geom,"geom");
			HX_STACK_LINE(222)
			++(_g);
			HX_STACK_LINE(223)
			geom->set_visible(val);
		}
	}
	HX_STACK_LINE(227)
	return this->visible = val;
}



CompositeGeometry_obj::CompositeGeometry_obj()
{
}

void CompositeGeometry_obj::__Mark(HX_MARK_PARAMS)
{
	HX_MARK_BEGIN_CLASS(CompositeGeometry);
	HX_MARK_MEMBER_NAME(geometry,"geometry");
	::phoenix::geometry::Geometry_obj::__Mark(HX_MARK_ARG);
	HX_MARK_END_CLASS();
}

void CompositeGeometry_obj::__Visit(HX_VISIT_PARAMS)
{
	HX_VISIT_MEMBER_NAME(geometry,"geometry");
	::phoenix::geometry::Geometry_obj::__Visit(HX_VISIT_ARG);
}

Dynamic CompositeGeometry_obj::__Field(const ::String &inName,bool inCallProp)
{
	switch(inName.length) {
	case 4:
		if (HX_FIELD_EQ(inName,"drop") ) { return drop_dyn(); }
		break;
	case 5:
		if (HX_FIELD_EQ(inName,"clear") ) { return clear_dyn(); }
		break;
	case 7:
		if (HX_FIELD_EQ(inName,"replace") ) { return replace_dyn(); }
		break;
	case 8:
		if (HX_FIELD_EQ(inName,"geometry") ) { return geometry; }
		if (HX_FIELD_EQ(inName,"toString") ) { return toString_dyn(); }
		break;
	case 9:
		if (HX_FIELD_EQ(inName,"translate") ) { return translate_dyn(); }
		if (HX_FIELD_EQ(inName,"set_color") ) { return set_color_dyn(); }
		if (HX_FIELD_EQ(inName,"set_depth") ) { return set_depth_dyn(); }
		if (HX_FIELD_EQ(inName,"set_group") ) { return set_group_dyn(); }
		if (HX_FIELD_EQ(inName,"set_dirty") ) { return set_dirty_dyn(); }
		break;
	case 10:
		if (HX_FIELD_EQ(inName,"set_shader") ) { return set_shader_dyn(); }
		if (HX_FIELD_EQ(inName,"set_locked") ) { return set_locked_dyn(); }
		break;
	case 11:
		if (HX_FIELD_EQ(inName,"set_texture") ) { return set_texture_dyn(); }
		if (HX_FIELD_EQ(inName,"set_visible") ) { return set_visible_dyn(); }
		break;
	case 12:
		if (HX_FIELD_EQ(inName,"has_geometry") ) { return has_geometry_dyn(); }
		if (HX_FIELD_EQ(inName,"add_geometry") ) { return add_geometry_dyn(); }
		break;
	case 13:
		if (HX_FIELD_EQ(inName,"set_clip_rect") ) { return set_clip_rect_dyn(); }
		break;
	case 14:
		if (HX_FIELD_EQ(inName,"add_to_batcher") ) { return add_to_batcher_dyn(); }
		break;
	case 15:
		if (HX_FIELD_EQ(inName,"remove_geometry") ) { return remove_geometry_dyn(); }
		break;
	case 18:
		if (HX_FIELD_EQ(inName,"set_primitive_type") ) { return set_primitive_type_dyn(); }
	}
	return super::__Field(inName,inCallProp);
}

Dynamic CompositeGeometry_obj::__SetField(const ::String &inName,const Dynamic &inValue,bool inCallProp)
{
	switch(inName.length) {
	case 8:
		if (HX_FIELD_EQ(inName,"geometry") ) { geometry=inValue.Cast< Array< ::Dynamic > >(); return inValue; }
	}
	return super::__SetField(inName,inValue,inCallProp);
}

void CompositeGeometry_obj::__GetFields(Array< ::String> &outFields)
{
	outFields->push(HX_CSTRING("geometry"));
	super::__GetFields(outFields);
};

static ::String sStaticFields[] = {
	String(null()) };

#if HXCPP_SCRIPTABLE
static hx::StorageInfo sMemberStorageInfo[] = {
	{hx::fsObject /*Array< ::Dynamic >*/ ,(int)offsetof(CompositeGeometry_obj,geometry),HX_CSTRING("geometry")},
	{ hx::fsUnknown, 0, null()}
};
#endif

static ::String sMemberFields[] = {
	HX_CSTRING("geometry"),
	HX_CSTRING("toString"),
	HX_CSTRING("clear"),
	HX_CSTRING("replace"),
	HX_CSTRING("has_geometry"),
	HX_CSTRING("add_geometry"),
	HX_CSTRING("remove_geometry"),
	HX_CSTRING("add_to_batcher"),
	HX_CSTRING("drop"),
	HX_CSTRING("translate"),
	HX_CSTRING("set_color"),
	HX_CSTRING("set_primitive_type"),
	HX_CSTRING("set_shader"),
	HX_CSTRING("set_texture"),
	HX_CSTRING("set_depth"),
	HX_CSTRING("set_group"),
	HX_CSTRING("set_locked"),
	HX_CSTRING("set_dirty"),
	HX_CSTRING("set_clip_rect"),
	HX_CSTRING("set_visible"),
	String(null()) };

static void sMarkStatics(HX_MARK_PARAMS) {
	HX_MARK_MEMBER_NAME(CompositeGeometry_obj::__mClass,"__mClass");
};

#ifdef HXCPP_VISIT_ALLOCS
static void sVisitStatics(HX_VISIT_PARAMS) {
	HX_VISIT_MEMBER_NAME(CompositeGeometry_obj::__mClass,"__mClass");
};

#endif

Class CompositeGeometry_obj::__mClass;

void CompositeGeometry_obj::__register()
{
	hx::Static(__mClass) = hx::RegisterClass(HX_CSTRING("phoenix.geometry.CompositeGeometry"), hx::TCanCast< CompositeGeometry_obj> ,sStaticFields,sMemberFields,
	&__CreateEmpty, &__Create,
	&super::__SGetClass(), 0, sMarkStatics
#ifdef HXCPP_VISIT_ALLOCS
    , sVisitStatics
#endif
#ifdef HXCPP_SCRIPTABLE
    , sMemberStorageInfo
#endif
);
}

void CompositeGeometry_obj::__boot()
{
}

} // end namespace phoenix
} // end namespace geometry
